from sage.all import *

def LL_cone(K):
    gens = K.lyapunov_like_basis()
    L = ToricLattice(K.lattice_dim()**2)
    return Cone(( g.list() for g in gens ), lattice=L, check=False)

def Sigma_cone(K):
    gens = K.cross_positive_operators_gens()
    L = ToricLattice(K.lattice_dim()**2)
    return Cone(( g.list() for g in gens ), lattice=L, check=False)

def Z_cone(K):
    gens = K.Z_operators_gens()
    L = ToricLattice(K.lattice_dim()**2)
    return Cone(( g.list() for g in gens ), lattice=L, check=False)

def pi_cone(K1, K2=None):
    if K2 is None:
        K2 = K1
    gens = K1.positive_operators_gens(K2)
    L = ToricLattice(K1.lattice_dim()*K2.lattice_dim())
    return Cone(( g.list() for g in gens ), lattice=L, check=False)
